"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createDevTools;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactRedux = require("react-redux");
var _instrument = require("@redux-devtools/instrument");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function logError(type) {
  if (type === 'NoStore') {
    console.error('Redux DevTools could not render. You must pass the Redux store ' + 'to <DevTools> either as a "store" prop or by wrapping it in a ' + '<Provider store={store}>.');
  } else {
    console.error('Redux DevTools could not render. Did you forget to include ' + 'DevTools.instrument() in your store enhancer chain before ' + 'using createStore()?');
  }
}
function createDevTools(children) {
  var _class;
  const monitorElement = _react.Children.only(children);
  const monitorProps = monitorElement.props;
  const Monitor = monitorElement.type;
  const ConnectedMonitor = (0, _reactRedux.connect)(state => state)(Monitor);
  return _class = class DevTools extends _react.Component {
    constructor(props, context) {
      super(props, context);
      if (_reactRedux.ReactReduxContext) {
        if (this.props.store && !this.props.store.liftedStore) {
          logError('NoLiftedStore');
        }
        return;
      }
      if (!props.store && !context?.store) {
        logError('NoStore');
        return;
      }
      if (context?.store) {
        this.liftedStore = context.store.liftedStore;
      } else {
        this.liftedStore = props.store.liftedStore;
      }
      if (!this.liftedStore) {
        logError('NoLiftedStore');
      }
    }
    render() {
      if (_reactRedux.ReactReduxContext) {
        // For react-redux@6
        if (this.props.store) {
          if (!this.props.store.liftedStore) {
            return null;
          }
          return /*#__PURE__*/_react.default.createElement(_reactRedux.Provider, {
            store: this.props.store.liftedStore
          }, /*#__PURE__*/_react.default.createElement(ConnectedMonitor, monitorProps));
        }
        return /*#__PURE__*/_react.default.createElement(_reactRedux.ReactReduxContext.Consumer, null, props => {
          if (!props || !props.store) {
            logError('NoStore');
            return null;
          }
          if (!props.store.liftedStore) {
            logError('NoLiftedStore');
            return null;
          }
          return /*#__PURE__*/_react.default.createElement(_reactRedux.Provider, {
            store: props.store.liftedStore
          }, /*#__PURE__*/_react.default.createElement(ConnectedMonitor, monitorProps));
        });
      }
      if (!this.liftedStore) {
        return null;
      }
      return /*#__PURE__*/_react.default.createElement(ConnectedMonitor, (0, _extends2.default)({}, monitorProps, {
        store: this.liftedStore
      }));
    }
  }, (0, _defineProperty2.default)(_class, "contextTypes", {
    store: _propTypes.default.object
  }), (0, _defineProperty2.default)(_class, "propTypes", {
    store: _propTypes.default.object
  }), (0, _defineProperty2.default)(_class, "instrument", options => (0, _instrument.instrument)((state, action) => Monitor.update(monitorProps, state, action), options)), _class;
}